-- by "Marhu" 
-- v 1.0
-- Date: 21.05.2013
-- "Script zum entladen von Stckgut"

tiertrailer = {};

function tiertrailer.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function tiertrailer:load(xmlFile)
	self.updateTipping = Utils.overwrittenFunction(self.updateTipping, tiertrailer.updateTipping);
	self.tiertrailerUnloadTime = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.GargoUnloadTime#value"), 1000);
	self.tiertrailerUnloadTimeBackup = self.tiertrailerUnloadTime;
	self.tiertrailerUnloadTimePig = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.GargoUnloadTime#pig"), 1000);
	self.tiertrailerUnloadTimebeef = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.GargoUnloadTime#beef"), 1000);
	self.beefCapacity = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.beefcapacity"), 4);
	self.pigCapacity = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.pigcapacity"), 9);
	
	self.hydraulicSounds = {};
	self.hydraulicSounds[1] = {};
	self.hydraulicSounds[2] = {};
	
	self.hydraulicSounds[1].file = getXMLString(xmlFile, "vehicle.hydraulicSoundbeef#file");
	self.hydraulicSounds[1].PitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hydraulicSoundbeef#pitchOffset"), 1.0);
	self.hydraulicSounds[1].Volume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hydraulicSoundbeef#volume"), 1.0);

	self.hydraulicSounds[2].file = getXMLString(xmlFile, "vehicle.hydraulicSoundPig#file");
	self.hydraulicSounds[2].PitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hydraulicSoundPig#pitchOffset"), 1.0);
	self.hydraulicSounds[2].Volume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hydraulicSoundPig#volume"), 1.0);
	
	self.fillSounds = {};
	self.fillSounds[1] = {};
	self.fillSounds[2] = {};

	self.fillSounds[1].file = getXMLString(xmlFile, "vehicle.fillSoundbeef#file");
	self.fillSounds[1].PitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fillSoundbeef#pitchOffset"), 1.0);
	self.fillSounds[1].Volume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fillSoundbeef#volume"), 1.0);

	self.fillSounds[2].file = getXMLString(xmlFile, "vehicle.fillSoundPig#file");
	self.fillSounds[2].PitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fillSoundPig#pitchOffset"), 1.0);
	self.fillSounds[2].Volume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fillSoundPig#volume"), 1.0);
	
	self.capacityBackup = self.capacity;
	self.isSoundReinitDone = false;
end;

function tiertrailer:delete()
end;

function tiertrailer:mouseEvent(posX, posY, isDown, isUp, button)
end;

function tiertrailer:keyEvent(unicode, sym, modifier, isDown)
end;

function tiertrailer:update(dt)
end;

function tiertrailer:updateTipping(superFunc, dt)
	if not self.isServer then
		return;
	end;
	if self:getCanTip() then
		local fillType = self.currentFillType;
	   
		local fillDelta = -self.fillLevel;
		if self.currentTipReferencePointIndex ~= nil then
			local animation = self.tipAnimations[self.currentTipReferencePointIndex];
			if animation ~= nil and animation.dischargeEndTime > animation.dischargeStartTime then
				if self:getCurrentTipAnimationTime() >= animation.dischargeStartTime then
					local m = self.capacity/((animation.dischargeEndTime-animation.dischargeStartTime)/animation.animationOpenSpeedScale);
					fillDelta = -m * dt;
				else
					fillDelta = 0;
				end
			end
		end
	   
		if fillDelta < 0 then
			fillDelta = -1
			self.LoadTime = (self.LoadTime or 0) + dt
			if self.LoadTime >= self.tiertrailerUnloadTime then
				self.LoadTime = 0
				local curFill = self.fillLevel;
				self:setFillLevel(self.fillLevel + fillDelta, fillType);
				local fillDelta = self.fillLevel - curFill;
				self.lastFillDelta = fillDelta;
		   
				if self.currentTipTrigger ~= nil then
					if self.currentTipTrigger.updateTrailerTipping ~= nil then
						self.currentTipTrigger:updateTrailerTipping(self, fillDelta, fillType);
					end
				elseif self:getCanTipToGround() then
					if fillDelta < 0 then
						local x, _,z = getWorldTranslation(self.groundDropArea.start);
						local x1,_,z1 = getWorldTranslation(self.groundDropArea.width);
						local x2,_,z2 = getWorldTranslation(self.groundDropArea.height);
		   
						local area = {x,z,x1,z1,x2,z2, -fillDelta*self.fillLevelToTippedFillLevel};
						local area, bitType, valueAccumulation = TrailerTipAreaEvent.runLocally(area, fillType, self.groundAmountAccumulation)
						if area ~= nil then
							g_server:broadcastEvent(TrailerTipAreaEvent:new(area, bitType, fillType));
						end;
						if valueAccumulation ~= nil then
							self.groundAmountAccumulation = valueAccumulation;
						end;
					end;
				end;
			end;
		end;
	else
		self:onEndTip();
	end;
end

function tiertrailer:draw()
end;